//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_3D.h"
#include "_3D.h"


//////////////////////////////////////////////////////////////////////////////
//    /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
int xD, yD, mD = 19, vFnow = 0, vCnow = 0;  //      
tfloat vMin = 0.5, vMax = 4, vDelta = vMax - vMin, vP = vMax - 2; 
tfloat_arr *value;                          //  ,      ... 
dwRGB vC1, vC2;                             // 


//////////////////////////////////////////////////////////////////////////////
//  .../////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
inline void VectLim(tvect &v, tfloat l)
{
  if (v.x > l) v.x = l; else if (v.x < -l) v.x = -l; 
  if (v.y > l) v.y = l; else if (v.y < -l) v.y = -l; 
  if (v.z > l) v.z = l; else if (v.z < -l) v.z = -l; 
};

inline dwRGB DIColor(dwRGB c)
{ 
  return RGBmultV(c,DrawIntensityI);
};

//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Falloff(int f)
{ DrawRect(RegionFull(),RGBis(f,f,f),modeMUL);
};

//////////////////////////////////////////////////////////////////////////////////////////////////
tfloat dist(tfloat x1, tfloat y1, tfloat x2, tfloat y2)
{
  x2 = x2 - x1; y2 = y2 - y1;
  return sqrt(x2*x2 + y2*y2);
};
 
tfloat constrain(tfloat v, tfloat mn, tfloat mx)
{ if (v < mn) v = mn; if (v > mx) v = mx;
  return v;
 
};
//////////////////////////////////////////////////////////////////////////////////////////////////
tfloat force = 0;

//////////////////////////////////////////////////////////////////////////////////////////////////
void mouseMoved()                           //  []  
{ 
  if (II.KeyDown[_Shift_]) floatLinc(force, 1, 0.0175); else force = 1;
  tfloat r, d = (!II.KeyDown[_Ctrl_]) * force;
  int xx = (II.Mouse.X - 4) / 8, yy = (II.Mouse.Y - 4) / 8,
      x1 = max(xx - mD, 0), y1 = max(yy - mD, 0),
      x2 = min(xx + mD, xD - 1), y2 = min(yy + mD, yD - 1); 
  for (int y = y1; y <= y2; y++)
  for (int x = x1; x <= x2; x++)
  { r = dist(xx, yy, x, y); 
    if (r < mD)(*value)[y * xD + x] = constrain((*value)[y * xD + x] + Hermit((tfloat)(mD - r) / mD * d), vMin, vMax);
  };  
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int keyExit = 0, HelpTimer = 0;

void keyPressed()                           //  [ ] 
{
  if (II.KeyUp[_Quote_]) vCnow = (3 + vCnow - 1) % 3;  
  if (II.KeyUp[_Enter_]) vCnow = (vCnow + 1) % 3;
  if (II.KeyUp[_CU_]) vFnow = 0;
  if (II.KeyUp[_CD_]) vFnow = 1; 
  if (II.KeyUp[_CR_]) vFnow = 2; 
  if (II.KeyUp[_CL_]) vFnow = 3;
  if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
  keyExit = (II.KeyUp[_Esc_]);
  switch(vCnow)
  { case 0: vC1 = RGBis(0, 50, 170); vC2 = RGBis(15, 155, 255); break;
    case 1: vC1 = RGBis(105, 0, 0); vC2 = RGBis(255, 150, 0); break;
    case 2: vC1 = RGBis(35, 65, 0); vC2 = RGBis(150, 215, 0); break;
  };
  II.Reset();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void filterUp()                             //  : 
{
  for (int y = 0; y < yD - 1; y++)          //      
  for (int x = 0; x < xD; x++)(*value)[y * xD + x] = (*value)[(y + 1) * xD + x] + fRandom(-0.15, 0.15); 
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void filterDown()                           //  : 
{
  for (int y = yD - 1; y > 1; y--)
  for (int x = 0; x < xD; x++)(*value)[y * xD + x] = (*value)[(y - 1) * xD + x] + fRandom(-0.15, 0.15); 
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void filterRight()                           //  : 
{
  for (int y = 0; y < yD; y++) 
  for (int x = xD - 1; x > 1; x--)(*value)[y * xD + x] = (*value)[y * xD + x - 1] + fRandom(-0.15, 0.15) ;  
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void filterLeft()                           //  : 
{
  for (int y = 0; y < yD; y++)
  for (int x = 0; x < xD - 1; x++)(*value)[y * xD + x] = (*value)[y * xD + x + 1] + fRandom(-0.15, 0.15);
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void vFilter()                              //   []
{
  switch(vFnow)
  { case 0: filterUp(); break;
    case 1: filterDown(); break;
    case 2: filterRight(); break;
    case 3: filterLeft(); break;
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void vDraw()                                // 
{
  tfloat *r;
  for (int y = 0; y < yD; y++)
  for (int x = 0; x < xD; x++)
  { r = &(*value)[y * xD + x];
    *r = constrain(*r * 0.97 - 0.005, vMin, vMax);
    DrawCircle(4 + x * 8, 4 + y * 8, *r, RGBblend(vC1, vC2,(*r - vMin) / vDelta * 255 + 0.5)); // :    
    if (*r > vP) DrawCircle(4 + x * 8, 4 + y * 8, *r - 2.75, vC2, modeADD);
  };  
  force = force * 0.9 - 0.0025;
};

//////////////////////////////////////////////////////////////////////////////
//     /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
TextSPR *info;

void CommonsInit()
{ RandomSeed();

  FC_FpsSet(AUTO);               //    
  FC_DrawPaint = Yes;            //  fps   DrawPaint();


  DrawPspMax = 5;              //    
  DrawSetPspClipPlanes(-115); //    , ,     
                               //   ,       
  //DrawSetFogPlanes(500,-115,effSEXPONENT); //     .

  Draw3D_Init();
  ForceActivate();
  ScreenLoadWait();

  info = new TextSPR(L"TYPE_EN_RU");

  xD = DrawXR / 8; yD = DrawYR  / 8;                      //    -
  value = (tfloat_arr *)malloc(xD * yD * sizeof(tfloat)); //                  
  for (int y = 0; y < yD; y++)
  for (int x = 0; x < xD; x++)(*value)[y * xD + x] = vMin;   //    

  OnMouseMoveDo(mouseMoved);
  OnKeyUpDo(keyPressed);
  keyPressed();
};


//////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsDone()
{
  free(value);
  delete info;
  Draw3D_Done();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawInfo()
{
  tRegion r = RegionCenterIs(272, 208);
  DrawRegionStore.Save(r);
  DrawRect(r, RGBis(50, 50, 50), modeMUL); 
  info->Place(0, 0, modeADD + fromCC, "Conrol Keys:\n\n\nQutes, Enter - change Color\n\nCursor - change Direction\n\nF1 - hide/show Help\n\nEsc - Exit\n\n\nAnd... - Mouse Move"); info->Draw();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawAll()
{
  if (HelpTimer) DrawInfo();
  DrawPaint();
  if (HelpTimer) { DrawRegionStore.Restore();  HelpTimer--; };
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();                  //   ;  

  //SetDrawIntensity(1);            //      
  //DrawScaleSet(1);                // 

  while (!keyExit)
   { Falloff(170);
     vDraw(); vFilter();          // 
     DrawAll();
   };   

  CommonsDone();                  //   ;
};
//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  WinName = L"CG : Array";      //    
  VS_CColor = RGBis(0,0,0);    //   
  DrawSet(FullScreen);         //   ( )  , FullScreen   
  //SetDraw(640,480);
  ProcessFunc = Main;           //    -  
  return on;
};
int Init_LetProcess = LetProcess();

