// File _3D.cpp  -   __main3d.cpp
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "_3D.h"

//////////////////////////////////////////////////////////////////////////////
int BuildQDec = on;
int RemQDec = on;
int OBJ_Camera = 0;

void *fnewOBJ() { return (void *)new BaseOBJ; }
void fdeleteOBJ(void *p) { delete(BaseOBJ *)p; }

BaseOBJ *COBJ = NULL;
int COBJn;
WCHAR *COBJname;
BaseCOARRAY OBJ((void **)&COBJ, &COBJn, &COBJname, fnewOBJ, fdeleteOBJ, 0);

decart QDEC;
decart CmQDEC;

int QCNVOBJ = 0;
int QCNV_mvVCenter;
tvect QCNV_VCenter;
tvect QCNV_QCenter;

int CmQCNV_mvVCenter;
tvect CmQCNV_VCenter;
tvect CmQCNV_QCenter;

int indxconv[OBJ_Conv_Deep];

//////////////////////////////////////////////////////////////////////////////
void OBJ_SetCamera(unsigned n)
{ 
  OBJ_Camera = n;
  if (!OBJ.Present(n)) OBJ.Current(n);
}

//////////////////////////////////////////////////////////////////////////////
void ConsDec(tvect& v, decart *d)
{
  if (fabs(v.z) > 0.4)
  { d->Oy.x = 1; d->Oy.y = 1; d->Oy.z = - (v.x * d->Oy.x + v.y * d->Oy.y) / v.z;
  } else if (fabs(v.x) > 0.4)
         { d->Oy.y = 1; d->Oy.z = 1; d->Oy.x = - (v.y * d->Oy.y + v.z * d->Oy.z) / v.x;
         } else { d->Oy.z = 1; d->Oy.x = 1; d->Oy.y = - (v.x * d->Oy.x + v.z * d->Oy.z) / v.y; }
  d->Oz = v; d->Oy.Norm(); d->Ox = d->Oy ^ d->Oz;
}

tvect tmpv, tmpv1, tmpv2;

//////////////////////////////////////////////////////////////////////////////
void ConsDirDec(tvect& v, decart *d)
{
  d->Oz = Norm(v); tmpv = tvect(0, 1, 0);
  d->Ox = Norm(tmpv ^ d->Oz);
  d->Oy = Norm(d->Oz ^ d->Ox);
}

//////////////////////////////////////////////////////////////////////////////
void GetRandVect(tvect ov, tfloat r1, tfloat r2, tfloat s, tvect *v)
{
  decart de;
  ConsDec(ov, &de);
  r2 = r2 * 2 * m_PI;
  v->x = r1 * sin(r2); v->y = r1 * cos(r2); v->z = 0;
  *v = Norm(ov + ConvDec(*v, de) * s);
};

//////////////////////////////////////////////////////////////////////////////
void OrientIn(tvect& p, unsigned to, tvect *p1)
{
  switch(to)
  { case RewX: p1->z = p.x;  p1->y = p.y;  p1->x = -p.z; break;
    case DirX: p1->z = -p.x; p1->y = p.y;  p1->x = p.z;  break;
    case RewY: p1->x = p.x;  p1->z = p.y;  p1->y = -p.z; break;
    case DirY: p1->x = p.x;  p1->z = -p.y; p1->y = p.z;  break;
    case RewZ: p1->x = p.x;  p1->y = -p.y; p1->z = -p.z; break;
    case DirZ: *p1 = p;
  };
};

//////////////////////////////////////////////////////////////////////////////
void OrientOut(tvect& p, unsigned to, tvect *p1)
{
  switch(to)
  { case RewX: p1->x = p.z;  p1->y = p.y;  p1->z = -p.x; break;
    case DirX: p1->x = -p.z; p1->y = p.y;  p1->z = p.x;  break;
    case RewY: p1->x = p.x;  p1->y = p.z;  p1->z = -p.y; break;
    case DirY: p1->x = p.x;  p1->y = -p.z; p1->z = p.y;  break;
    case RewZ: p1->x = p.x;  p1->y = -p.y; p1->z = -p.z; break;
    case DirZ: *p1 = p;
  };
};

//////////////////////////////////////////////////////////////////////////////
void SphConv(tvect p, unsigned to, tfloat *ax, tfloat *ay)
{
  OrientIn(p, to, &p);
  tfloat mx = p.x * p.x, my = p.y * p.y, mz = p.z * p.z, s,
         am = sqrt(mx + mz + my), sm = sqrt(mx + my);

  if (am != 0) s = sm / am; else { *ax = 0; *ay = 0; return; };
  if (p.z < 0) *ay = (0.5*m_PI - acos(s)) * m_PI; else *ay = (0.5*m_PI + acos(s)) * m_PI;
  if (fabs(p.y) > fabs(p.x))
  { s = fabs(p.y) / sm;
    if (p.x < 0)
    { if (p.y < 0) *ax = acos(s) * 0.5*m_PI; else *ax = (m_PI - acos(s)) * 0.5*m_PI;
    } else if (p.y < 0) *ax = (2*m_PI - acos(s)) * 0.5*m_PI; else *ax = (m_PI + acos(s)) * 0.5*m_PI;
  } else { s = fabs(p.x) / sm;
           if (p.x < 0)
           { if (p.y < 0) *ax = (0.5*m_PI - acos(s)) * 0.5*m_PI; else *ax = (0.5*m_PI + acos(s)) * 0.5*m_PI;
           } else if (p.y < 0) *ax = (1.5*m_PI + acos(s)) * 0.5*m_PI; else *ax = (1.5*m_PI - acos(s)) * 0.5*m_PI;
         }
}

//////////////////////////////////////////////////////////////////////////////
void CylConv(tvect p, unsigned to, tfloat *ax, tfloat *dy)
{
  OrientIn(p, to, &p);
  *dy = p.z;
  tfloat s, sm = sqrt(p.x * p.x + p.y * p.y);
  if (fabs(p.y) > fabs(p.x))
  { s = fabs(p.y) / sm;
    if (p.x < 0)
    { if (p.y < 0) *ax = acos(s) * 0.5*m_PI; else *ax = (m_PI - acos(s)) * 0.5*m_PI;
    } else if (p.y < 0) *ax = (2*m_PI - acos(s)) * 0.5*m_PI; else *ax = (m_PI + acos(s)) * 0.5*m_PI;
  } else { s = fabs(p.x) / sm;
           if (p.x < 0)
           { if (p.y < 0) *ax = (0.5*m_PI - acos(s)) * 0.5*m_PI; else *ax = (0.5*m_PI + acos(s)) * 0.5*m_PI;
           } else if (p.y < 0) *ax = (1.5*m_PI + acos(s)) * 0.5*m_PI; else *ax = (1.5*m_PI - acos(s)) * 0.5*m_PI;
         }
}

//////////////////////////////////////////////////////////////////////////////
void COBJ_CMove(tfloat x, tfloat y, tfloat z)
{
  tvect p = tvect(x, y, z);
  if (BuildQDec) COBJ->CMove(x, y, z); else { COBJ->VCenter = COBJ_ConvVect(COBJ->VCenter);
                                               p += COBJ->VCenter; COBJ->VCenter = COBJ_DeConvVect(p);
                                             }
}

//////////////////////////////////////////////////////////////////////////////
// QDec
void SetBuildQDec(int m) { BuildQDec=m; }
void ResetQDec() { RemQDec=BuildQDec; BuildQDec=off; }
void RestoreQDec() { BuildQDec=RemQDec; }

//////////////////////////////////////////////////////////////////////////////
void OBJ_Copy(unsigned sn, unsigned tn) { OBJ.Current(tn); * ((BaseOBJ *)OBJ.Get(tn)) = * ((BaseOBJ *)OBJ.Get(sn)); }

//////////////////////////////////////////////////////////////////////////////
void COBJ_QDec()
{
  unsigned rc;
  ResetQDec();
  tvect QCenter = COBJ->ACenter;
  if (COBJ->NextConv != 0) { decart QDec = COBJ->Dec;
                             rc = COBJn;
                             OBJ.Current(COBJ->NextConv);
                             QDec.Ox = COBJ_ConvVect(QDec.Ox);
                             QDec.Oy = COBJ_ConvVect(QDec.Oy);
                             QDec.Oz = COBJ_ConvVect(QDec.Oz);
                             QCenter = COBJ_Conv(QCenter);
                             OBJ.Current(rc);
                             COBJ->QDec = QDec;
                           } else COBJ->QDec = COBJ->Dec;
  COBJ->QCenter = QCenter; COBJ->Rottate = ((COBJ->QDec.Ox.x != 1) || (COBJ->QDec.Oy.y != 1));
  RestoreQDec();
}

//////////////////////////////////////////////////////////////////////////////
void COBJ_DirToPoint(tvect p)
{
  COBJ->Dec.Oz = Norm(p - COBJ->ACenter);
  COBJ->Dec.Ox = Norm(tvect(0,1,0) ^ COBJ->Dec.Oz);
  COBJ->Dec.Oy = COBJ->Dec.Oz ^ COBJ->Dec.Ox;
  COBJ->QDec = COBJ->Dec; COBJ->Rottate = on;
}

//////////////////////////////////////////////////////////////////////////////
void COBJ_DirTo(word n)
{
  tvect p;
  ResetQDec();
  unsigned rc = COBJn;
  OBJ.Current(n); p = COBJ_Conv(tvect(0, 0, 0));
  OBJ.Current(rc); RestoreQDec(); //!!!
  COBJ_DirToPoint(p);
};

//////////////////////////////////////////////////////////////////////////////
void COBJ_Direct()
{
  if (COBJ->Direct) if (COBJ->DirOBJ) COBJ_DirTo(COBJ->DirOBJ); else COBJ_DirToPoint(COBJ->DirPoint);
}

//////////////////////////////////////////////////////////////////////////////
void OBJs_Rotate()
{
  if (OBJ.Start()) do { COBJ->Rotate(); } while (OBJ.Next());
}

//////////////////////////////////////////////////////////////////////////////
void OBJs_QDec()
{
  if (OBJ.Start()) do { COBJ_QDec(); } while (OBJ.Next());
}

//////////////////////////////////////////////////////////////////////////////
void OBJs_Direct()
{
  if (OBJ.Start()) do { COBJ_Direct(); } while (OBJ.Next());
}

//////////////////////////////////////////////////////////////////////////////
void OBJs_RotateQDec() { OBJs_Rotate(); OBJs_QDec(); }

//////////////////////////////////////////////////////////////////////////////
void OBJs_DirectRotateQDec() { OBJs_Direct(); OBJs_Rotate(); OBJs_QDec(); }

//////////////////////////////////////////////////////////////////////////////
//  
BaseOBJ :: BaseOBJ() { Default(); }
BaseOBJ :: ~BaseOBJ() { }

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetScale(tfloat Xs, tfloat Ys, tfloat Zs) { Scale.x=Xs; Scale.y=Ys; Scale.z=Zs; }
void BaseOBJ :: SetEScale(tfloat Xs, tfloat Ys, tfloat Zs) { EScale.x=Xs; EScale.y=Ys; EScale.z=Zs; }
void BaseOBJ :: SetMap(int Xv, int Yv, int Zv) { Map.Vx=Xv; Map.Vy=Yv; Map.Vz=Zv; }

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetTSMap(tmap SMp)
{
  tfloat Rcos,Rsin;
  decart De;
  tmap Mp;
  SMap.Vx = 0; SMap.Vy = 0; SMap.Vz = 0;
  if (SMp.Vx | SMp.Vy | SMp.Vz)
  { Rcos = Ccos; Rsin = Csin;
    Ccos = Scos; Csin = Ssin;
    Mp=Map; Map=SMp; De=Dec;
    SetDecart(1,0,0,0,1,0,0,0,1); Rotate();
    SDec=Dec; Dec=De; Map=Mp;
    Ccos=Rcos; Csin=Rsin;
  }
  SMap=SMp;
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetSMap(int Xv, int Yv, int Zv)
{
  tmap SMp;
  SMp.Vx=Xv; SMp.Vy=Yv; SMp.Vz=Zv;
  SetTSMap(SMp);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetSCirc(tfloat ug)
{
  SCirc=ug; Scos=cos(ug); Ssin=sin(ug); SetTSMap(SMap);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetCirc(tfloat ug)
{
  Circ=ug; Ccos=cos(ug); Csin=sin(ug);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: NoRotate()
{
  Map.Vx = 0; Map.Vy = 0; Map.Vz = 0; SMap = Map;
  SetCirc(0); SetSCirc(0);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetTDecart(decart De)
{  
  Dec.Ox = Norm(De.Ox); Dec.Oy = Norm(De.Oy); Dec.Oz = Norm(De.Oz);
};

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetDecart(tfloat Xx, tfloat Xy, tfloat Xz,
                           tfloat Yx, tfloat Yy, tfloat Yz,
                           tfloat Zx, tfloat Zy, tfloat Zz)
{
  decart De;
  De.Ox.x=Xx; De.Ox.y=Xy; De.Ox.z=Xz;
  De.Oy.x=Yx; De.Oy.y=Yy; De.Oy.z=Yz;
  De.Oz.x=Zx; De.Oz.y=Zy; De.Oz.z=Zz;
  SetTDecart(De);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetOrient(unsigned m)
{ 
  switch(m)
  { case DirZ: SetDecart(1, 0, 0, 0, 1, 0, 0, 0, 1);   break;
    case RewZ: SetDecart(1, 0, 0, 0, -1, 0, 0, 0, -1); break;
    case  DirY: SetDecart(1, 0, 0, 0, 0, -1, 0, 1, 0); break;
    case  RewY: SetDecart(1, 0, 0, 0, 0, 1, 0, -1, 0); break;
    case  DirX: SetDecart(0, 0, -1, 0, 1, 0, 1, 0, 0); break;
    case  RewX: SetDecart(0, 0, 1, 0, 1, 0, -1, 0, 0); break;
    case  RandOr:
    Dec.Ox = tvect(1 - 2 * Random(), 1 - 2 * Random(), 1 - 2 * Random());
    Dec.Oy = tvect(1 - 2 * Random(), 1 - 2 * Random(), 1 - 2 * Random());
    Dec.Ox.Norm();
    Dec.Oz = Norm(Dec.Ox ^ Dec.Oy);
    Dec.Oy = Norm(Dec.Oz ^ Dec.Ox);
  }
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetVCenter(tfloat xc, tfloat yc, tfloat zc)
{
  VCenter = tvect(xc,yc,zc); MvVCent = ((xc != 0) || (yc != 0) || (zc != 0));
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetACenter(tfloat xc, tfloat yc, tfloat zc)
{
  ACenter = tvect(xc, yc, zc);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: MoveACenter(tfloat xc, tfloat yc, tfloat zc)
{
  ACenter += tvect(xc, yc, zc);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: MoveVCenter(tfloat xc, tfloat yc, tfloat zc)
{
  VCenter += tvect(xc, yc, zc);
  MvVCent = ((VCenter.x != 0) || (VCenter.y != 0) || (VCenter.z != 0));
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SetToOBJ(unsigned t) { ToOBJ=t; }
void BaseOBJ :: SetDirect(int d) { Direct=d; }
void BaseOBJ :: SetDirOBJ(unsigned d) { DirOBJ=d; }
void BaseOBJ :: SetDirPoint(tfloat x, tfloat y, tfloat z) { DirPoint=tvect(x,y,z); }
void BaseOBJ :: SetNextConv(unsigned n) { NextConv=n; }

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: Default()
{
  SetNextConv(0);
  SetToOBJ(0);
  SetDirOBJ(0);
  SetDirPoint(0,0,0);
  SetDirect(off);
  SetScale(1,1,1);
  SetEScale(1,1,1);
  SetACenter(0,0,0);
  SetVCenter(0,0,0);
  SetOrient(DirZ);
  SetMap(0,0,0);
  SetSMap(0,0,0);
  SetCirc(0);
  SetSCirc(0);
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: SubRotate(int k, int vst, int vnd)
{
  tvect a, b, c, d, v;
  switch(vst)
  { case 0: v = Dec.Ox; break;
    case 1: v = Dec.Oy; break;
    case 2: v = Dec.Oz;
  }
  a = v * Ccos; d = v * (Csin * (-k));
  switch(vnd)
  { case 0: v = Dec.Ox; break;
    case 1: v = Dec.Oy; break;
    case 2: v = Dec.Oz;
  }
  b = v * (Csin * k); c = v * Ccos; v = a + b;
  switch(vst)
  { case 0: Dec.Ox = v; break;
    case 1: Dec.Oy = v; break;
    case 2: Dec.Oz = v;
  }
  v = c + d;
  switch(vnd)
  { case 0: Dec.Ox = v; break;
    case 1: Dec.Oy = v; break;
    case 2: Dec.Oz = v;
  }
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: Rotate()
{
  decart De;
  tvect Ac,Vc;
  if ((SMap.Vx | SMap.Vy | SMap.Vz))
  { De = Dec; Dec = SDec; Ac = ACenter; Vc = VCenter;
    ACenter.x = 0; ACenter.y = 0; ACenter.z = 0;
    VCenter = ACenter;
    De.Ox = Conv(De.Ox);
    De.Oy = Conv(De.Oy);
    De.Oz = Conv(De.Oz);
    ACenter = Ac; VCenter = Vc; Dec = De;
  };
  if (Map.Vx != 0) SubRotate(Map.Vx, 1, 2);
  if (Map.Vy != 0) SubRotate(Map.Vy, 2, 0);
  if (Map.Vz != 0) SubRotate(Map.Vz, 0, 1);
  Rottate = ((Dec.Ox.x != 1) || (Dec.Oy.y != 1));
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: Conv(tvect p)
{
  if (MvVCent) p += VCenter;
  if (Rottate) p = ConvDec(p,Dec);
  return p + ACenter;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: ConvVect(tvect p)
{
  if (Rottate) return ConvDec(p, Dec); else return p;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: DeConv(tvect p)
{
  p -= ACenter;
  if (Rottate) p = DeConvDec(p, Dec);
  if (MvVCent) p -= VCenter;
  return p;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: DeConvVect(tvect p)
{
  if (Rottate) return DeConvDec(p, Dec); else return p;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: DeQConv(tvect p)
{
  p -= QCenter;
  if (Rottate) p = DeConvDec(p, QDec);
  if (MvVCent) p -= VCenter;
  return p;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: DeQConvVect(tvect p)
{
  if (Rottate) return DeConvDec(p, QDec); else return p;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: QConv(tvect p)
{
  if (MvVCent) p += VCenter;
  if (Rottate) p = ConvDec(p, QDec);
  return p + QCenter;
}

//////////////////////////////////////////////////////////////////////////////
tvect BaseOBJ :: QConvVect(tvect p)
{
  if (Rottate) return ConvDec(p, QDec); else return p;
}

//////////////////////////////////////////////////////////////////////////////
void BaseOBJ :: CMove(tfloat x, tfloat y, tfloat z)
{
  tvect p;
  p.x = x; p.y = y; p.z = z;
  if (BuildQDec) VCenter = ConvDec(VCenter, QDec); else VCenter = ConvDec(VCenter, Dec);
  p += VCenter;
  if (BuildQDec) VCenter = DeConvDec(p, QDec); else VCenter = DeConvDec(p, Dec);
}

//////////////////////////////////////////////////////////////////////////////
