// File _DRAW_2D_GDIplus.h

///////////////////////////////////////////////////////////////////////////////
#ifndef __DRAW_2D_GDIplus__
#define __DRAW_2D_GDIplus__

///////////////////////////////////////////////////////////////////////////////
#include "_WIN.h"

///////////////////////////////////////////////////////////////////////////////
extern int GDInow;

#define RT_BINARYDATA L"BINARYDATA"

extern wchar_t *                      GDIbitmapRT; //   // RT_BITMAP / RT_JPG   ,       

extern ULONG_PTR                    GDItoken;
extern GdiplusStartupInput          GDIinput;
extern Bitmap*                      GDIbitmap;
extern BitmapData*                  GDIbitmapData;
extern dwRGB_arr                    *GDIbits;
extern int                          GDIbitmapLineSize;
extern int                          GDIbitmapSize;
extern int                          GDIbitmapXres;
extern int                          GDIbitmapYres;
extern PixelFormat                  GDIpixelFormat;

///////////////////////////////////////////////////////////////////////////////
inline void GDIrun()
{
  if (!GDInow) if (GdiplusStartup(&GDItoken, &GDIinput, 0)) HaltError(L"GDI+ (WindowsXP or later) support not present"); 
  GDInow++;
}

///////////////////////
inline void GDIstop() { if (GDInow) { GDInow--; if (!GDInow) GdiplusShutdown(GDItoken); } }

///////////////////////
inline HRSRC GDIfindImageResource(HMODULE hModule, wchar_t * lpName)
{
  HRSRC hrsrc = FindResource(hmCommonResource, lpName, GDIbitmapRT = RT_BITMAP); 
  if (!hrsrc) hrsrc = FindResource(hmCommonResource, lpName, GDIbitmapRT = RT_BINARYDATA); 
  return hrsrc;            
}
 
///////////////////////
int GDIbitmapLock(Bitmap* bitmap = GDIbitmap, PixelFormat pf = GDIpixelFormat); 
void GDIbitmapUnlock(); 
Bitmap* BitmapFromResource(wchar_t * name);
int GDIbitmapFromResource(wchar_t * name);
int GDIbitmapFromFile(wchar_t * name);

int GDIbitmapLoad(wchar_t * name, int fromRes = -1); // fromRes = Yes -  
                                                     // fromFile = No -  
                                                     //   -         
void GDIbitmapRelase();
extern tfloat GDIbitmapScaleX; //   ,     - xr  yr - 
extern tfloat GDIbitmapScaleY;
int GDIbitmapResize(int xr, int yr = -1);
extern tfloat GDIbitmapScaleXres; //   -  
extern tfloat GDIbitmapScaleYres;

#define modeSIZEFIT  0
#define modeSIZEREAL 1
#define modeSIZEOUT  2
#define formEQUAL    0
#define formWIDE     1
#define formHI       2

extern int GDIbitmapResizeMode;            // default modeSIZEFIT 
extern tfloat GDIbitmapResizeAspect;       //   
extern tfloat GDIbitmapResizeRAspect;      // "" > 1 -    . < 1 -   
extern int GDIbitmapResizeForm;            // 0 -  , 1 - , 2 -  
extern int GDIbitmapClear;                 //    VS_CColor;

Bitmap *BitmapResize(Bitmap *source, int xr, int yr);
void Br20(wchar_t * name, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int);

///////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
// Save Images from Hdc -  .
//    image/bmp
//    image/jpeg
//    image/gif
//    image/tiff
//    image/png
#define bitmapBMP 0
#define bitmapJPG 1
#define bitmapGIF 2
#define bitmapTIF 3
#define bitmapPNG 4

extern int GDIbitmapSAVEtype;            //  
extern WCHAR *GDIbitmapSAVEdelimiter01;
extern WCHAR *GDIbitmapSAVEdelimiter02;
extern WCHAR *GDIbitmapSAVEpath;         // (  )
extern WCHAR *GDIbitmapSAVEname;         // 
extern WCHAR *GDIbitmapSAVEext;          // 
extern WCHAR GDIbitmapSAVEfullname[1024]; //  -
extern unsigned GDIbitmapSAVEincBase;    //    
extern unsigned GDIbitmapSAVEincOffs;    //  
                                         //  , ,  : e:\\temp\\img_0003_0005.png
extern unsigned GDIbitmapSAVEincBaseDigits; //     ...
extern unsigned GDIbitmapSAVEincOffsDigits;

void GDIbitmapSAVEfullnameDo();          //   - 
int GDIbitmapSAVE(BYTE *bits = NULL, unsigned xr = 1, unsigned yr = 1, int loffs = -1, PixelFormat pf = PixelFormat32bppRGB); //    -    HDC
int GDIbitmapSAVE(wchar_t *path, BYTE *bits = NULL, unsigned xr = 1, unsigned yr = 1, int loffs = -1, PixelFormat pf = PixelFormat32bppRGB);

extern int GDIsshotXR; //    0,         
extern int GDIsshotYR;
int GDIsshotSAVE(wchar_t *path1 = GDIbitmapSAVEpath, wchar_t *path2 = NULL, BYTE *bits = NULL, unsigned xr = 1, unsigned yr = 1, int loffs = -1);

void GDIbitmapSAVEincBaseDo();          //  
void GDIbitmapSAVEincOffsDo(); 
////////////////////////////////////////////////////////////////////////////
#endif