// File _DRAW_3D.h
//  Z-  
//////////////////////////////////////////////////////////////////////////////
#ifndef  _DRAW_3D__
#define  _DRAW_3D__

//////////////////////////////////////////////////////////////////////////////
#include "_DRAW_2D.h"
#include "_MATH_Vector.h"

//////////////////////////////////////////////////////////////////////////////
#define dmZB      0x00000100
#define dmNOTZB   0x00000200

//////////////////////////////////////////////////////////////////////////////
typedef int tzbarr[1024];
typedef tzbarr *tpzbarr;

//////////////////////////////////////////////////////////////////////////////
extern tfloat DrawPspMax;    //    
extern tfloat DrawPlanePsp;  //  
extern tfloat DrawPlanePsp2;   // 
extern tfloat DrawPlanePspMax; //   .

extern tfloat DrawStereoOffs;  //  

extern tfloat DrawPlaneClip; //  
extern int DrawPlaneClipI;  //   

extern int DrawFog;              // = effNO, effLINEAR, effEXPONENT. 
extern tfloat DrawPlaneFogFar;   // ,   
extern tfloat DrawPlaneFogNear;  // 
extern tfloat DrawFogDist;       // 
extern int DrawPlaneFogFarI;  //  
extern int DrawPlaneFogNearI;
extern int DrawFogDistI;

extern int DrawRFog;              //   
extern tfloat DrawPlaneRFogFar;
extern tfloat DrawPlaneRFogNear;
extern tfloat DrawRFogDist;     
extern int DrawPlaneRFogFarI;
extern int DrawPlaneRFogNearI;
extern int DrawRFogDistI;
extern tvect DrawRFogPoint; //    , .. .

extern int DrawNearFadeDistI;
extern tfloat DrawNearFadeDist;

extern tpzbarr ZB;       // Z- 

extern tfloat DrawLimit; //     , ..   
                          //  DrawLimit,   .
extern int DrawLimitI;    //  , ..   
                         //  DrawLimitI,   .

extern int DrawDeepSort;    //      ,   = Yes 
extern int DrawZBuse;       //  Z-.   = no;                        
//////////////////////////////////////////////////////////////////////////////
#define ZB_ExactUp 8     //  ,  - 8,   

//////////////////////////////////////////////////////////////////////////////
void ZB_Init();
void ZB_Done();
void ZB_Clear();

void DrawPrepare(); //   ;
void DrawSetPspClipPlanes(tfloat, tfloat = -1);  //  : (    )  .  

void DrawSetFogPlanes(tfloat, tfloat, int = effSEXPONENT);
                       // c ,   , . 
void DrawSetRFogPlanes(tfloat, tfloat, int = effSEXPONENT, tvect = 0);    
                       // "c"  ,   , ,   ,   . 
                       //     VS_CColor
/////////////////////////////////////
inline tfloat DrawPspK(tfloat z)  //   .    z,  0 .  = 1,    = 2
{  
  if (z <= DrawPlanePspMax) return DrawPspMax; else return DrawPlanePsp2 / (DrawPlanePsp2 - z);
};

/////////////////////////////////////
inline int DrawFogfor (tfloat z) //   0..255 -  ""     
{
  z -= DrawPlaneFogNear;
  if (z <= 0) return 255;
   else switch(DrawFog)
        { case effSEXPONENT: return shExp0(z, DrawFogDist) * 255 + 0.5; 
          case effEXPONENT: return hHExp0(z, DrawFogDist) * 255 + 0.5;
          case effHERMIT: return HExp(z, DrawFogDist); 
          case effNO: return 255; 
          default: return lExp0(z, DrawFogDist) * 255 + 0.5; 
        };
};

/////////////////////////////////////
inline tfloat fDrawFogfor (tfloat z) //   0..1 -  ""     
{
  if (!DrawFog || ((z -= DrawPlaneFogNear) <= 0)) return 1.0;
   else switch(DrawFog)
        { case effSEXPONENT: return shExp0(z, DrawFogDist); 
          case effEXPONENT: return hHExp0(z, DrawFogDist);
          case effHERMIT: return HExp(z, DrawFogDist); 
          default: return lExp0(z, DrawFogDist); 
        };
};

/////////////////////////////////////
inline int DrawRFogfor (tvect p) //   0..255 -  ""     
{
  p.x -= DrawRFogPoint.x; p.z -= DrawRFogPoint.z;
  p.z = sqrt(p.x*p.x + p.z*p.z) - DrawPlaneRFogNear;
  if (p.z <= 0) return 255;
   else switch(DrawFog)
        { case effSEXPONENT: return shExp0(p.z, DrawRFogDist) * 255 + 0.5; 
          case effEXPONENT: return hHExp0(p.z, DrawRFogDist) * 255 + 0.5;
          case effHERMIT: return HExp(p.z, DrawRFogDist); 
          default: return lExp0(p.z, DrawRFogDist) * 255 + 0.5; 
        };
};

/////////////////////////////////////
inline int DrawNearFadefor (tfloat z)
{
  if (DrawNearFadeDistI) { if ((z -= DrawPlaneClip) < DrawNearFadeDist) return to255(z / DrawNearFadeDist); else return 255;
                         } else return 255;  
};

/////////////////////////////////////
inline tfloat fDrawNearFadefor (tfloat z)
{
  if (DrawNearFadeDistI) { if ((z -= DrawPlaneClip) < DrawNearFadeDist) return z / DrawNearFadeDist; else return 1;
                         } else return 1;  
};

/////////////////////////////////////
inline tfloat fDrawRFogfor (tvect p) //   0..255 -  ""     
{
  p.x -= DrawRFogPoint.x; p.z -= DrawRFogPoint.z;
  p.z = sqrt(p.x*p.x + p.z*p.z) - DrawPlaneRFogNear;
  if (p.z <= 0) return 1.0;
   else switch(DrawFog)
        { case effSEXPONENT: return shExp0(p.z, DrawRFogDist); 
          case effEXPONENT: return hHExp0(p.z, DrawRFogDist);
          case effHERMIT: return HExp(p.z, DrawRFogDist); 
          default: return lExp0(p.z, DrawRFogDist); 
        };
};

//////////////////////////////////////////////////////////////////////////////
//  2D  Z-
//////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
extern int DrawDeepZ;  //  

//////////////////////////////////////////////////////////////////////////////
void Draw3D_Init();
void Draw3D_Done();

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/*
extern void (*D3Dset)();

void D3Dset_n_Z_n(); //  
void D3Dset_B_Z_n();
void D3Dset_n_Z_O();
void D3Dset_B_Z_O();

//////////////////////////////////////////////////////////////////////////////
inline void D3Dset_ChkBord_UpdZB_OffsDo(int chkB = Yes, int updZB = Yes, int offsDo = Yes)
                                               //  ,
                                               //  Z- 
                                               //  
{
  switch(chkB | (updZB << 1) | (offsDo << 2))
  { case 0: D3Dset = D2Dset_n_n; break;
    case 1: D3Dset = D2Dset_B_n; break;
    case 2: D3Dset = D3Dset_n_Z_n; break;
    case 3: D3Dset = D3Dset_B_Z_n; break;
    case 4: D3Dset = D2Dset_n_O; break;
    case 5: D3Dset = D2Dset_B_O; break;
    case 6: D3Dset = D3Dset_n_Z_O; break;
    case 7: D3Dset = D3Dset_B_Z_O; break;
  };
}/**/

//////////////////////////////////////////////////////////////////////////////
extern tvect DrawCenter;
extern tfloat DrawZoom;

inline void DrawCenterCrop(tfloat x, tfloat y, tfloat z, tfloat x2, tfloat y2, tfloat z2)
{
  if (DrawCenter.x < x) DrawCenter.x = x; if (DrawCenter.x > x2) DrawCenter.x = x2; 
  if (DrawCenter.y < y) DrawCenter.y = y; if (DrawCenter.y > y2) DrawCenter.y = y2; 
  if (DrawCenter.z < z) DrawCenter.z = z; if (DrawCenter.z > z2) DrawCenter.z = z2; 
};

inline void DrawCenterCropSym(tfloat x, tfloat y, tfloat z) { DrawCenterCrop(-x,-y,-z,x,y,z); };

//////////////////////////////////////////////////////////////////////////////
//    ,   m(< 1) -  .
inline void DrawCenterSmoothCrop(tfloat x, tfloat y, tfloat z, tfloat x2, tfloat y2, tfloat z2, tfloat m = 0.05)
{
  x = DrawCenter.x - x; y = DrawCenter.y - y; z = DrawCenter.z - z;
  x2 = DrawCenter.x - x2; y2 = DrawCenter.y - y2; z2 = DrawCenter.z - z2;
  if (x < 0) DrawCenter.x -= x * m; if (x2 > 0) DrawCenter.x -= x2 * m; 
  if (y < 0) DrawCenter.y -= y * m; if (y2 > 0) DrawCenter.y -= y2 * m; 
  if (z < 0) DrawCenter.z -= z * m; if (z2 > 0) DrawCenter.z -= z2 * m; 
};

inline void DrawCenterSmoothCropSym(tfloat x, tfloat y, tfloat z, tfloat m = 0.05) { DrawCenterSmoothCrop(-x,-y,-z,x,y,z,m); };

//////////////////////////////////////////////////////////////////////////////
inline void DrawCenterPspCrop(tfloat x, tfloat y, tfloat z, tfloat x2, tfloat y2, tfloat z2)
{
  if (DrawCenter.z < z) DrawCenter.z = z; if (DrawCenter.z > z2) DrawCenter.z = z2; 
  tfloat k = DrawPspK(DrawCenter.z);
  x /= k; y /= k; x2 /= k; y2 /= k; 
  if (DrawCenter.x < x) DrawCenter.x = x; if (DrawCenter.x > x2) DrawCenter.x = x2; 
  if (DrawCenter.y < y) DrawCenter.y = y; if (DrawCenter.y > y2) DrawCenter.y = y2; 
};

inline void DrawCenterPspCropSym(tfloat x, tfloat y, tfloat z) { DrawCenterPspCrop(-x,-y,-z,x,y,z); };

//////////////////////////////////////////////////////////////////////////////
#endif
