//     
//////////////////////////////////////////////////////////////////////////////
#ifndef __DRAWGRAPHPRIM__
#define __DRAWGRAPHPRIM__
//////////////////////////////////////////////////////////////////////////////
#include "_DRAW_3D.h"
#include "_COARRAY.h"
//////////////////////////////////////////////////////////////////////////////

#define vasCIRC   0x00010000   //   

extern unsigned GPR_Drawed;
extern unsigned GPR_Saved;

//////////////////////////////////////////////////////////////////////////////
void GPR_FogBlend(int &r, int &g, int &b, int fog);
void GPR_WhiteBlend(int &r, int &g, int &b, int fog);
void GPR_RGBmult(unsigned &r, unsigned &g, unsigned &b, unsigned m);

//////////////////////////////////////////////////////////////////////////////
class BaseGPR   
  { public:
    unsigned ViewAs; //  (  )
    unsigned Type, Mode;   //    
    dwRGB Color; //,     RGBAis(10,70,140, 200);
    tfloat mFog,            //    . 
           Scale;           // 
           //mScale, pScale;  //   CIRC -      , ..         
    int Next; //    BaseGPR -  ;
     
    BaseGPR();
    ~BaseGPR();
    void (*DrawUnit)(tvect p, tfloat, dwRGB, int);
    void SetViewAs(unsigned vas = vasCIRC, dwRGB color = RGBis(255,255,255), wchar_t * name = NULL); // name -   
    //void Load(wchar_t * name); 
    int Draw(tvect p, tfloat scale = 1, dwRGB color = RGBis(255,255,255), dwRGB *pcolor = NULL, tfloat effect = 1);
    int Save(tvect p, tfloat scale = 1, dwRGB color = RGBis(255,255,255), dwRGB *pcolor = NULL, tfloat effect = 1);
};
//////////////////////////////////////////////////////////////////////////////
extern BaseCOARRAY GPR;

extern BaseGPR *CGPR;
extern int CGPRn; 
extern WCHAR *CGPRname;

//////////////////////////////////////////////////////////////////////////////
void GPR_Copy(unsigned, unsigned);
void GPR_Init(int draw = Yes);    // 
void GPR_Prepare(); //     
void GPR_Done(int draw = Yes);    // 

//////////////////////////////////////////////////////////////////////////////
struct tGPRfileHeader { unsigned XR, YR, DrawHRImode, DrawMultiscope, FLT_GhostEffect, FLT_GhostMode, Items;
                        dwRGB Color; 
                        float DrawIntensity;
                      };

struct tGPRfileData { float X, Y, Rad;
                      unsigned short cR, cG, cB, cA, Mode;
                    };

typedef tGPRfileData tGPRfileData_arr[1024];

void GPRfileWStart();
void GPRfileWrite(tfloat x, tfloat y, tfloat rad, unsigned r, unsigned g, unsigned b, unsigned a, unsigned m);
void GPRfileWFinish(wchar_t *path);

//////////////////////////////////////////////////////////////////////////////
#endif