// File __nsfn3d.h
//////////////////////////////////////////////////////////////////////////////
#ifndef _MATH_Noise__
#define _MATH_Noise__
//////////////////////////////////////////////////////////////////////////////
#include "_3D.h"
//////////////////////////////////////////////////////////////////////////////
#define NonSpline off
#define Spline     on
//////////////////////////////////////////////////////////////////////////////
class Noise1D
  { public:
    tfloat_arr *DPtr;
    tfloat LnSec;
    tfloat_arr *FPtr;
    int Secfast;
    unsigned Sec;
    Noise1D();
    ~Noise1D();
    void Clear();
    void Make(unsigned xs = 10, tfloat ln = 50);
    void Generate();
    void GenerateNsfast(tfloat base = 0, tfloat jitter = 100, int t = interpHERMIT, tfloat tt = 0);
    tfloat GetNsfast(int i);
    tfloat GetNs(tfloat x, int t = interpHERMIT, tfloat tt = 0);
    tfloat Noise(tfloat x, unsigned c = 1, int t = interpHERMIT, tfloat tt = 0);
    protected:
    unsigned size,d,tp;
    tfloat fd;
  };
//////////////////////////////////////////////////////////////////////////////
class Noise2D
  { public:
    tfloat_arr *DPtr;
    tfloat LnSec;
    unsigned SecX,SecY;
    Noise2D();
    ~Noise2D();
    void Clear();
    void Make(unsigned xs = 10, unsigned ys = 10, tfloat ln = 50);
    void Generate();
    tfloat GetNs(tfloat x, tfloat y, int t = interpHERMIT, tfloat tt = 0, int t2 = -1);
    tfloat Noise(tfloat x, tfloat y, unsigned c = 1, int t = interpHERMIT, tfloat tt = 0, int t2 = -1);
    protected:
    unsigned size, pat, dx, dy, tp;
    tfloat fdx, fdy;
  };
//////////////////////////////////////////////////////////////////////////////
class Noise3D
  { public:
    tfloat_arr *DPtr;
    tfloat LnSec;
    unsigned SecX,SecY,SecZ;
    Noise3D();
    ~Noise3D();
    void Clear();
    void Make(unsigned xs = 10, unsigned ys = 10, unsigned zs = 10, tfloat ln = 50);
    void Generate();
    tfloat GetNs(tvect p, int t = interpHERMIT, tfloat tt = 0);
    tfloat Noise(tvect p, unsigned c = 1, int t = interpHERMIT, tfloat tt = 0);
    protected:
    unsigned size, pat1, pat2, dx, dy, dz, tp;
    tfloat fdx, fdy, fdz;
  };
//////////////////////////////////////////////////////////////////////////////  
#endif
