// File _MATH_RandomBJ.h                 
//////////////////////////////////////////////////////////////////////////////
#ifndef  _MATH_RandomBJ__
#define  _MATH_RandomBJ__
//////////////////////////////////////////////////////////////////////////////
#include "_MATH.h"
#include "_MATH_Vector.h"
#include "_RGB.h"
//////////////////////////////////////////////////////////////////////////////
struct tBJdwRGB
  { dwRGB B;
    int J;
  };

struct tBJint
  { int B,J;
  };

struct tBJvect
  { tvect B;
    tfloat J;
  };

struct tBJvectvect
  { tvect B, J;
  };

struct tBJfloat
  { tfloat B,J;
  };

/////////////////////////////////////////////////////////////////////////////////////////////////
inline dwRGB BJitter(tBJdwRGB p)
{
  if (p.J) return RGBis(sR(p.B) + Random(-p.J, p.J), sG(p.B) + Random(-p.J, p.J), sB(p.B) + Random(-p.J, p.J)); else return p.B; 
};

inline dwRGB mBJitter(tBJdwRGB p)
{
  if (p.J) 
   { int j = Random(-p.J, p.J);
     return RGBis(sR(p.B) + j, sG(p.B) + j, sB(p.B) + j);
   } else return p.B; 
};

inline int BJitter(tBJint p)
{
  if (p.J) return p.B + Random(-p.J,p.J); else return p.B;
};

inline tfloat BJitter(tBJfloat p)
{
  if (p.J == 0) return p.B; else return p.B + fRandom(-p.J,p.J);
};

inline tvect BJitter(tBJvect p)
{
  if (p.J == 0) return p.B; else return tvect(p.B.x + fRandom(-p.J,p.J),p.B.y + fRandom(-p.J,p.J),p.B.z + fRandom(-p.J,p.J));
};

inline tvect BJitter(tBJvectvect p)
{
  return tvect(p.B.x + fRandom(-p.J.x,p.J.x),p.B.y + fRandom(-p.J.y,p.J.y),p.B.z + fRandom(-p.J.z,p.J.z));
};

inline tvect BJitterI(tBJfloat p)  //  -     BJ- 
{ 
  tvect v; v.NormRand();
  return v * BJitter(p);
};

/////////////////////////////////////////////////////////////////////////////////////////////////
inline tBJdwRGB BJ(dwRGB b, int j)
{
  tBJdwRGB bj;
  bj.B = b; bj.J = j;
  return bj;
};

inline tBJint BJ(int b, int j)
{
  tBJint bj;
  bj.B = b; bj.J = j;
  return bj;
};

inline tBJfloat BJ(float b, float j)
{
  tBJfloat bj;
  bj.B = b; bj.J = j;
  return bj;
};

inline tBJfloat BJ(double b, double j)
{
  tBJfloat bj;
  bj.B = b; bj.J = j;
  return bj;
};

inline tBJvect BJ(tvect b, tfloat j)
{
  tBJvect bj;
  bj.B = b; bj.J = j;
  return bj;
};

inline tBJvectvect BJ(tvect b, tvect j)
{
  tBJvectvect bj;
  bj.B = b; bj.J = j;
  return bj;
};

//////////////////////////////////////////////////////////////////////////////
#endif
